#include <stdlib.h>
#include <stdio.h>

#define pageL 256

/* tablebase byte entry semispan length */

#define tbbe_ssL ((pageL - 4) / 2)

/* tablebase signed byte entry values */

#define bev_broken  (tbbe_ssL + 1)  /* illegal or busted */

#define bev_mi1     tbbe_ssL        /* mate in 1 move */
#define bev_mimin   1               /* mate in 126 moves */

#define bev_draw    0               /* draw */

#define bev_limax   (-1)            /* mated in 125 moves */
#define bev_li0     (-tbbe_ssL)     /* mated in 0 moves */

#define	bev_limaxx	(-tbbe_ssL - 1)	/* mated in 126 moves */
#define	bev_miminx	(-tbbe_ssL - 2)	/* mate in 127 moves */

// Some constants for 16-bit tables

#define L_pageL 65536

/* tablebase short entry semispan length */

#define L_tbbe_ssL ((L_pageL - 4) / 2)

/* tablebase signed short entry values */

#define L_bev_broken  (L_tbbe_ssL + 1)		/* illegal or busted */

#define L_bev_mi1     L_tbbe_ssL			/* mate in 1 move */
#define L_bev_mimin   1						/* mate in 32766 moves */

#define L_bev_draw    0						/* draw */

#define L_bev_limax   (-1)					/* mated in 32765 moves */
#define L_bev_li0     (-L_tbbe_ssL)			/* mated in 0 moves */

#define	L_bev_limaxx	(-L_tbbe_ssL - 1)	/* mated in 32766 moves */
#define	L_bev_miminx	(-L_tbbe_ssL - 2)	/* mate in 32767 moves */

// Convertion from 8-bit to 16-bit score
// UNDONE: Maybe implement via lookup table?

#define	S_to_L(tbt)\
	(\
	 (0 == tbt) ? 0:\
	 (tbt > 0) ? (bev_broken != tbt ? tbt + 32640 : L_bev_broken):\
	 (tbt >= bev_li0) ? tbt - 32640:\
	 (bev_limaxx == tbt) ? -32640:\
	 /*bev_miminx == tbt*/  32640\
	)

#define	L_to_S(tbt)\
	(\
	 (0 == tbt) ? 0:\
	 (tbt > 0) ? (L_bev_broken != tbt ? tbt - 32640 : bev_broken):\
	 tbt + 32640\
	)

int main (int argc, char *argv[])
{
    FILE    *fin, *fout;
    short   *ps;
    char    *pc;
    int     i, count;

    if (3 != argc) {
        printf ("Usage: tb16to8 infile outfile\n");
        exit(1);
    }
    ps = (short*) malloc (1024*1024*32*2);
    pc = (char*) malloc (1024*1024*32);
    if (ps == NULL || pc == NULL) {
        printf ("Cannot allocate buffers\n");
        exit(1);
    }
    fin  = fopen (argv[1], "rb");
    fout = fopen (argv[2], "wb");
    if (fin == NULL || fout == NULL) {
        printf ("Cannot open/create files\n");
        exit(1);
    }
    for (;;) {
        count = fread (ps, 2, 1024*1024*32, fin);
        if (0 == count)
            break;
        for (i = 0; i < count; i ++)
            pc[i] = (char) L_to_S (ps [i]);
        if (count != fwrite (pc, 1, count, fout)) {
            printf ("Cannot write to file\n");
            exit(1);
        }
    }
    if (fclose(fin) | fclose(fout)) {
        printf ("Cannot close files\n");
        exit(1);
    }
    return 0;
}
